#include "image.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "places.h"
#include "tools.h"

#define STEPSIZE (8)


int main(int argc, char *argv[])
{
	image_t img;
	image_t map;
	load_from_file(&map,"/home/casandro/badge/server/SLZ_kaartA4_website.pbm");
	init_badge(&img);
	int end=0;
	int c=0;
	int x=0;
	int y=0;
	int xmax=map.width- img.width;
	int ymax=map.height-img.height;
	int mode=0;
	int splace=0;
	while (end==0) {
		if (x<0) x=0;
		if (y<0) y=0;
		if (x>xmax) x=xmax;
		if (y>ymax) y=ymax;
		if (mode==0) {
			copy_image(&map,&img,x,y);
			write_image(&img);
			c=gc();
			if (c==-1) {
				end=1;
			}
			if (c=='h') x=x-1*STEPSIZE;
			if (c=='j') y=y+4*STEPSIZE;
			if (c=='k') y=y-4*STEPSIZE;
			if (c=='l') x=x+1*STEPSIZE;
			if (c=='\n') mode=1;
		} else
		if (mode==1) {
			int lines=img.height/8-1;
			int top=splace-(lines/2);
			if (top<0) top=0;
			int bottom=top+lines;
			if (bottom>PLACECNT) bottom=PLACECNT;
			int n;
			//clear display
			putchar(BDG_CLRSCR);
			for (n=top;n<PLACECNT;n++) {
				//set xor pattern
				if (n==splace) {
					putchar(0xfb);
					putchar(0xff);
				} else {
					putchar(0xfb);
					putchar(0x00);
				}
				//set position
				putchar(0xfd);
				uint16_t p=(n-top)*8*img.width;
				putchar(p%256);
				putchar(p/256);
				printf("%16s",places[n].name);
			}
			//reset XOR pattern
			putchar(0xfb);
			putchar(0x00);
			refresh_badge();	
			c=gc();
			if (c==-1) {
				end=1;
			}
			if (c=='j') splace=splace+1;
			if (c=='k') splace=splace-1;
			if (c=='\n') {
				x=places[splace].x/8-img.width/2;
				y=places[splace].y-img.height/2;
				mode=0;
			}
			if (splace<0) splace=0;
			if (splace>=PLACECNT) splace=PLACECNT-1;
		}
	}
//	while ( (c=gc())!='\n') {
		
//	} 
}
